#!/usr/bin/python

import threading, random, socket
import random
from SOAPpy import *

class Uscan(threading.Thread):


    def __init__(self, uip, ip, soapInfo, queue, verbose, portList, mapList, scr = ''):

        threading.Thread.__init__ (self)
        self.stopIt = threading.Event()
        self.portList = portList
        self.verbose = verbose
	if scr == '':
	    self.cursesMode = 0
	else:
	    self.scr = scr
	    self.cursesMode = 1

        self.ip = ip
        self.uip = uip
        self.soapInfo = soapInfo
        self.port = soapInfo[4]
        self.queue = queue
	self.mapList = mapList


    def run(self):

        for port in self.portList:
            if self.stopIt.isSet():
                break
                sys.exit()
            open = False
            thisport = random.randint(30000, 40000)
            if self.cursesMode:
                self.scr.printMessage("[*] Trying port "+str(port)+" on "+self.ip+" "+self.uip+":"+str(thisport))
            else:
                print("[*] Trying port "+str(port)+" on "+self.ip+" "+self.uip+":"+str(thisport))
            endpoint = "http://%s:%s%s" % (self.uip, self.port, self.soapInfo[2])
            namespace = self.soapInfo[0]
            soapaction = namespace+'#AddPortMapping'
            server = SOAPProxy(endpoint, namespace)

            try:
                server._sa(soapaction).AddPortMapping(NewRemoteHost="",
                NewExternalPort=thisport,
                NewProtocol="TCP",
                NewInternalPort=port,
                NewInternalClient=self.ip,
                NewEnabled=1,
                NewPortMappingDescription=thisport,
                NewLeaseDuration=0)
            except Exception, err:
                if self.cursesMode:
                    self.scr.printMessage("[E]Couldn't add port "+str(thisport)+" with "+str(port)+" on "+self.uip+":"+str(err))
                else:
                    print("[E]Couldn't add port "+str(thisport)+" with "+str(port)+" on "+self.uip+":"+str(err))

            try:
                s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
                s.connect((self.uip, thisport))
                open = 1
		self.mapList.append(self.uip+":"+str(thisport)+"|"+self.ip+":"+str(port))
                if self.cursesMode:
                    self.scr.printMessage("Mapped: "+self.uip+":"+str(thisport)+"<->"+self.ip+":"+str(port))
                else:
                    print("Mapped: "+self.uip+":"+str(thisport)+"<->"+self.ip+":"+str(port))
                s.close()
            except Exception, err:
		open = 0
                s.close()
                if self.verbose: 
                    if self.cursesMode:
                        self.scr.printMessage("Closed port "+str(err))
                    else:
                        print("Closed port "+str(err))

            if not open:
                endpoint = "http://%s:%s%s" % (self.uip, self.port, self.soapInfo[2])
                namespace = self.soapInfo[0]
                soapaction = namespace+"#DeletePortMapping"
                server = SOAPProxy(endpoint, namespace)
                try:
                    if self.cursesMode and self.verbose:
		        self.scr.printMessage("Deleting: "+str(thisport))
                    else:
                        if self.verbose: print("Deleting: "+str(thisport))
                    server._sa(soapaction).DeletePortMapping(NewRemoteHost="",
                    NewExternalPort=thisport,
                    NewProtocol="TCP")
                except Exception, err:
                     if self.cursesMode:
                         self.scr.printMessage("[E] Couldn't delete port "+str(thisport))
                     else:
                         print("[E] Couldn't delete port "+str(thisport))

